Javaのthrowとthrowsの使い分けをする方法【初心者向け】現役エンジニアが解説

初心者向けにJavaのtry...catch文におけるthrowステートメントとthrowsステートメントの使い方について解説しています。これらは両方とも例外処理に用いられます。2つの違いと記述方法、実行した場合の処理を実際に書きながら覚えていきましょう。

TechAcademyマガジンは受講者数No.1のオンラインプログラミングスクールTechAcademy [テックアカデミー]が運営。初心者向けに解説した記事を公開中。現役エンジニアの方はこちらをご覧ください。

Javaのtry…catch文におけるthrowステートメントとthrowsステートメントの使い分けについて、テックアカデミーのメンター(現役エンジニア)が実際のコードを使用して初心者向けに解説します。

目次

そもそもJavaについてよく分からないという方は、Javaとは何なのか解説した記事を読むとさらに理解が深まります。

 

田島悠介

今回は、Javaに関する内容だね!

大石ゆかり

どういう内容でしょうか?

田島悠介

try…catch文におけるthrowステートメントと throwsステートメントの使い方について詳しく説明していくね!

大石ゆかり

お願いします!

 

例外エラーとは

開発されたアプリが利用(運用)されるとさまざまなエラーが発生します。

必須項目が未入力などのエラーは、入力チェックなどでユーザーに操作をうながすことができますが、データベースやネットワークなどへの接続エラー、イレギュラーな操作など、開発時点では想定しにくいエラーもあります。

今回は後者の例外エラーについて、発生した際にどのように処理をするのか、例外発生時のハンドリング(対応)に関して説明します。

例外ハンドリングは、予期せぬ異常終了などアプリが停止することを防ぐだけでなく、複数人でのアプリ開発などでも必要な知識なのでしっかりと理解しましょう。

 

例外処理とは

例外処理を実装することで、継続的にシステムがユーザーに予期せぬエラーの発生を知らせることができます。

例外が発生する可能性のある処理を、tryブロックで囲み、発生時の対応をcatchブロック内に記述することで例外処理を実行できます。

(例)

Path deleteFilePath = Paths.get("D:/test/01.txt");

try{
    /*1:処理*/
}
catch(Exception e){
    /*2:例外発生時の処理*/
}finally{
    /*3:例外発生有無に関わらず、共通で行う処理*/
}

 

正常に削除できた場合は、catchブロックの処理は行われず、finallyブロックの処理のみ実行されます。

上記例ですと、1⇒3の順で実装されている処理が行われます。

一方、例外が発生するとcatchブロック内の処理が実行された後、finallyブロックの処理に進みます。

1(途中で例外発生)⇒2⇒3の順で処理が行われます。

主にアプリから見て外部のファイルやデータベースなどの更新・削除・参照する際には例外が発生する可能性があるため、上記のように例外処理を行う必要があります。

catchブロックでは主に例外が発生した際の、エラー通知やデータベース更新箇所などの巻き戻し(ロールバック)などを実装することが多いです。

finallyブロックでは、不要なオブジェクトやデータベースとの接続などを破棄する処理を実装することがあります。
またfinallyブロックは省略可能です。

例外処理に関して簡単に説明しましたが、例外処理を各関数ごとに実装するのは非効率ですよね。

そこでJavaにはthorwsステートメントという便利な機能がありますのでご紹介します。

 

[PR] Javaプログラミングで挫折しない学習方法を動画で公開中

throwステートメントとthrowsステートメントとは

どちらも例外処理を記述する際に使用します。

1. throwステートメント

「throw」を使用すると任意のタイミングで例外を発生させて、例外処理を行うことができます。

 

例えばある変数の値が指定した範囲にないときに必ずエラーにしたいとします。

(例)

if(i < 0){
  throw new Exception("iが指定範囲を超えています");
}

上記の例ではiが負の数の場合に例外を発生させるようにしています。

throwステートメントは「throw new 例外クラス」と記述します。

この場合はExceptionクラスを使用しています。

 

例外の発生後は、このthrowステートメントに対応するcatch節に処理が移ります。

(例)

try{
  if(i < 0){
    throw new Exception("iが指定範囲を超えています");
  }
}
catch(Exception e){
    e.printStackTrace();//throwの後ここに処理が移る
}

 

2. throwsステートメント

例えば、複数のメソッドを使用した処理を書く際、例外処理を各メソッドの中ではなく呼び出し元でまとめて行いたい場合があります。

そういった場合、各メソッドの宣言時にthrowsステートメントを加えることで、例外処理を呼び出し元に移譲できます。

(例)

private void func() throws Exception{・・略・・}

throwsステートメントはメソッド引数定義の後に「throws 例外クラス」と記述します。

例外クラスはカンマで区切って複数指定することも可能です。

 

上の例の場合、funcメソッド内で例外が発生すると、その呼び出し元のcatch節に処理が移ります。

(例)

public static void main(String[] args) {
  try{
    func();//呼び出し元
  }
  catch(Exception e){
    e.printStackTrace();//funcメソッド内で例外が発生するとここに処理が移る
  }
}

上記の例で使用しているExceptionクラスはすべての例外に共通の親クラスなので、どんな例外でもキャッチできます。

ただ、実際は発生しうる例外に合わせて処理を分ける方が望ましいです。
(サンプルプログラムを参照)

 

実際に書いてみよう

下記のサンプルプログラムは、コンソール画面で実行後にキー入力をしてください。

Enterキーで入力内容を確定します。

キーが未入力、数字以外の入力、1か2以外の数字を入力、これらのいずれかの場合に例外が発生します。

例外発生時は、各場合ごとに異なるメッセージを表示します。

  • キーが未入力の場合:「キー入力してください」
  • 数字以外の入力の場合:「数字を入力してください」
  • 1か2以外の数字を入力:「1か2を入力してください」

例外の発生箇所とそれがどこで処理されるのかをみて、throwとthrowsの使い方を再確認してください。

1か2を入力した場合は「正しいキー入力を受け付けました」を表示します。

 

ソースコード

import java.util.Scanner;

public class ExTest {

  public static void main(String[] args) {
      ExTest exTest = new ExTest();
      //コンソールでのキー入力を要求する
      String input = exTest.read();
      try {
        int no = exTest.getNo(input);
        System.out.println("入力結果:"+no+" 正しいキー入力を受け付けました");

      //getNoメソッドで発生した例外はここから下のcatch節で処理する
      } catch (NumberFormatException e) {
        System.out.println("数字を入力してください");
      } catch (IllegalArgumentException e) {
        System.out.println("1か2を入力してください");
      } catch (Exception e){
        System.out.println("想定外のエラーが発生しました。");
      }
  }

  private String read(){
    String input;
    Scanner scan = new Scanner(System.in);
    input = scan.nextLine();//コンソールで入力した文字を取得する
    scan.close();
    try {
          if(input == null || input.equals("")){
            //何も入力せずにEnterが押された場合は例外を発生させる
            throw new IllegalArgumentException();
        }
    } catch (IllegalArgumentException e) {
        //上でスローされた例外をキャッチする
        System.out.println("キー入力してください");
        System.exit(1);//プログラムを終了する。
    } catch (Exception e){
        System.out.println("想定外のエラーが発生しました。"); 
    }
    return input;
 }

  //このメソッドで発生した例外は呼び出し元で処理する
  private int getNo(String s) throws NumberFormatException,IllegalArgumentException{

    //数字に変換できない文字を入力した場合はNumberFormatExceptionが発生する
    int i = Integer.parseInt(s);

    if(i != 1 && i != 2){
      //1か2以外の数字を入力した場合は例外を発生させる
      throw new IllegalArgumentException("1か2を入力してください");
    }
    return i;
  }
}

 

まとめ

今回は例外処理におけるtry、catch、finallyブロックとthorw、throwsステートメントについて学びました。

例外処理をしっかりと実装しないと、思わぬシステム障害や停止時間を発生させてしまいます。

どこで例外が発生する可能性があるか、どこでどのように例外を処理するか、とても大切ですのでぜひ実装の際に参考にしてみてくださいね。

 

執筆してくれたメンター

永井 浩平(ナガイ コウヘイ)

バックエンド、フロント、クラウドなど幅広い業務を行ってきました。
DB全般とspring(Java)、フロント系言語が得意分野です。現在はBtoBtoC事業を行っている会社で
社内SEとして勤務している傍
テックアカデミーのフロントエンドコース・Javaコースのメンターとして活動しています。

大石ゆかり

内容が分かりやすくて良かったです!

田島悠介

ゆかりちゃんも分からないことがあったら質問してね!

大石ゆかり

分かりました。ありがとうございます!

 

Javaを学習中の方へ

これで解説は終了です、お疲れさまでした。

  • つまずかず「効率的に」学びたい
  • 副業や転職後の「現場で使える」知識やスキルを身につけたい

プログラミングを学習していて、このように思ったことはありませんか?

テックアカデミーのJavaコースでは、第一線で活躍する「プロのエンジニア」が教えているので、効率的に実践的なスキルを完全オンラインでしっかり習得できます。

合格率10%の選考を通過した、選ばれたエンジニアの手厚いサポートを受けながら、JavaやServletの技術を使ったWebアプリケーション開発を学べます。

まずは一度、無料体験で学習の悩みや今後のキャリアについて話してみて、「現役エンジニアから教わること」を実感してみてください。

時間がない方、深く知ってから体験してみたい方は、今スグ見られる説明動画から先に視聴することをおすすめします!